
// Fortsetzung aus DEMO1.CPP
// wir kommen zur eigentlichen Textkorrektur...

 
void AskError(char *word, char *mess)
// wir haben ein unbekanntes Wort; entsprechend der eingestellten
// Korrektur-Art wird verfahren (melden oder markieren)
{
// Fehlerart in Fenster ausgeben
pstart->SendDlgItemMessage(IDC_CORR_MESS, WM_SETTEXT,(WPARAM)0,(LPARAM) ((LPCSTR) mess));
// alte Vorschlagsliste lschen
pstart->SendDlgItemMessage(IDC_CORR_LIST, LB_RESETCONTENT,0,0L);

switch (correct_art_num) {
   case CORR_AUTO_CORR : // Wort markieren & weitergehen;
        markWord(word);
        break;
   case CORR_MANU_SCHNELL :
        dispWord(word);      // Wort in Fehlerfenster anzeigen
        CorrProposal = FALSE;
        CorrectSetButtons(); // Korrekturbuttons aktivieren
        break;
   default :
        WORD_LIST *list = new(WORD_LIST);
        dispWord(word);      // Wort in Fehlerfenster anzeigen
        ShowWait();          // Sanduhr
        NAME c_word;
        strcpy(c_word,word);
        GetProposals(&c_word,1,list); // Korr.vorschlge zu c_word holen (API)
        HideWait();          // Sanduhr aus
        showCorrect(list);   // Korrvorschlge in Liste anzeigen
    	CorrProposal = TRUE;
        CorrectSetButtons(); // Korrekturbuttons aktivieren
	}
}


BOOL isCorrWin = FALSE; // Fenster ist beim Start geschlossen

void CorrectCloseWindow() // Meldungsfenster schlieen
{
    if (isCorrWin == TRUE) {
        isCorrWin = FALSE;
        MemSetDictionary(FALSE); // Speicherlexikon schlieen (API)
        UsrClose();              // Benutzerwrterbcher schlieen (API)
        SysClose();              // Systemwrterbcher schlieen (API)
        WBopen = FALSE;
        delete(pstart);          // Korrekturfenster entfernen
        return;
    }       
}


 
void continueCorrect() // korrigiere bis zum nchsten unbekannten Wort
{
RESULT res;
NAME   readword;
NAME   oldword = "";
BOOL   typo;
MODE   cmode;
NAME_REC sysdic;        // Systemwrterbcher
NAME_REC usrdic;        // Benutzerwrterbcher
GRAM   grammar;
NAME   hyphinfo;

DWORD xpos = CorrGetCursorPos();  // starte bei Cursorposition
if (xpos == -1) {                // am Textende angelangt
    doCorrect = FALSE;
    return;
}
	
line_ofs = LOWORD(xpos);
line_nr = HIWORD(xpos);

CorrectResetButtons();            // unntige Buttons deaktivieren
GetInfos(sysdic,usrdic);          // Namen der WB holen
typo  = correct_opt_typo;         // Typografie prfen?
cmode = MODE(correct_opt_comp);   // Umfang der Wortzusammensetzungen

if (WBopen == FALSE) {       // WB sind noch nicht geffnet
   res = SysOpen(&sysdic);   // (API)
   if (res != CORR_OK) {
      NAME etext;
      if (ErrorText(res,&etext) == CORR_OK) // (API)
         AskError(readword,etext);
      CorrectCloseWindow();
      return;
   }
   res = UsrOpen(&usrdic);   // (API)
   if (res != CORR_OK) {
      NAME etext;
      if (ErrorText(res,&etext) == CORR_OK)  // (API)
         AskError(readword,etext);
      CorrectCloseWindow();
      return;
   }
   res = MemSetDictionary(TRUE);  // (API)
   WBopen = TRUE;
}   
ShowWait(); // Sanduhr whrend des Prfvorganges
	
while (doCorrect) {   // prfe bis zum nchsten unbekannten Wort
   if (GetNextWord(readword) == FALSE) {
      CorrectCloseWindow();
// Fenster schlieen & Korr-Button zurcksetzen
      return;
   }

// ist Wort schon im Speicherlexikon?
   res = MemTestWord(&readword,typo);  // (API)

   if (res != CORR_OK) {
// wird Wort in Lexika gefunden?
      res = SysTestWord(&readword,&grammar,typo);  // (API)
      if (res == CORR_UNK_WORD) {
         if (UsrTestWord(&readword,&grammar,typo) == CORR_UNK_WORD) { // (API)
// zusammengesetztes Wort?
            if (TestCompoundWord(&readword,cmode,typo) == CORR_OK) ; // (API)
            else {
               NAME etext;
// wenn nein, dann nur Fehler in Typografie?
               if ((typo == TRUE) &&
                  ((MemTestWord(&readword,FALSE) == CORR_OK) ||  // (API)...
                  (SysTestWord(&readword,&grammar,FALSE) == CORR_OK) ||
                  (UsrTestWord(&readword,&grammar,FALSE) == CORR_OK) ||
                  (TestCompoundWord(&readword,cmode,FALSE) == CORR_OK)))
                  ErrorText(CORR_TYPO,&etext);
               else
                  ErrorText(CORR_UNK_WORD,&etext);   // (API)
	
                AskError(readword,etext);
                if (correct_art_num != CORR_AUTO_CORR) return;
// Bei Auto-Modus einfach weiterkorrigieren!
            }
         }
         else if (res == CORR_OK) MemSetWord(&readword);  // (API)
      }
      else if (res == CORR_OK) MemSetWord(&readword);  // (API)
   }

// ist die Silbentrennung richtig?
   res = HyphTestWord(&readword,&grammar,&hyphinfo,correct_opt_trenn); // (API)
   if (res != CORR_OK) {
      NAME etext;
      if (ErrorText(CORR_HYPH,&etext) == CORR_OK)  // (API)
         AskError(readword,etext);
      if (correct_art_num != CORR_AUTO_CORR) return;
// Bei Auto-Modus einfach weiterkorrigieren!
   }
  		
// Wortwiederholungen prfen
   if (correct_opt_wwdh == TRUE) {
      if (strcmp(readword,oldword) == 0) {
         NAME etext;
         if (ErrorText(CORR_WORD_WDH,&etext) == CORR_OK)  // (API)
            AskError(readword,etext);
         if (correct_art_num != CORR_AUTO_CORR) return;
// Bei Auto-Modus einfach weiterkorrigieren!
      }
      strcpy(oldword,readword);
   }
}
HideWait();
}

 
void CorrectOpenWindow() // Korrekturfenster ffnen
{
    if (isCorrWin == FALSE) {                                                 
        pstart = new CCorrStart; // Fenster nicht-modal erzeugen
        isCorrWin = doCorrect;
    }       
    else doCorrect = TRUE;

    if (doCorrect == TRUE) { // Fenster gibts, jetzt auch anzeigen
        pstart->ShowWindow(SW_SHOW);
        line_nr = 0; // ab Textbeginn korrigieren
        line_ofs = 0;
        continueCorrect(); // Korrigiere bis zum nchsten unbekannten Wort
    }
}
 


